import { checkCharacter } from "./validation";

export class Plugboard {
	links: Map<string, string>;

	constructor() {
		this.links = new Map();
	}

	stecker(a: string, b: string) {
		checkCharacter(a, "a");
		checkCharacter(b, "b");

		if (this.links.has(a) || this.links.has(b)) {
			throw new Error("one of the provided letters is already mapped");
		}

		this.links.set(a, b);
		this.links.set(b, a);
	}

	unlink(a: string) {
		checkCharacter(a, "a");

		if (!this.links.has(a)) return;

		const b = this.links.get(a)!;

		this.links.delete(a);
		this.links.delete(b);
	}

	in(char: string) {
		return this.links.get(char) ?? char;
	}
}
